import { IDeviceConfig } from "../config";
import { ReferenceToken, ReceiverConfiguration, ReceiverMode } from "./types";
export declare class ONVIFReceiver {
    private config;
    constructor(config: IDeviceConfig);
    /**
     * Returns the capabilities of the receiver service. The result is returned in a typed answer.
     */
    static GetServiceCapabilities(): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Lists all receivers currently present on a device. This operation is mandatory.
     *
     */
    static GetReceivers(): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Retrieves the details of a specific receiver. This operation is mandatory.
     *
     */
    static GetReceiver(ReceiverToken: ReferenceToken): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Creates a new receiver. This operation is mandatory, although the service may
     *   raise a fault if the receiver cannot be created.
     *
     */
    static CreateReceiver(Configuration: ReceiverConfiguration): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Deletes an existing receiver. A receiver may be deleted only if it is not
     *   currently in use; otherwise a fault shall be raised.
     *   This operation is mandatory.
     *
     */
    static DeleteReceiver(ReceiverToken: ReferenceToken): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Configures an existing receiver. This operation is mandatory.
     *
     */
    static ConfigureReceiver(ReceiverToken: ReferenceToken, Configuration: ReceiverConfiguration): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Sets the mode of the receiver without affecting the rest of its configuration.
     *   This operation is mandatory.
     *
     */
    static SetReceiverMode(ReceiverToken: ReferenceToken, Mode: ReceiverMode): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     *
     *   Determines whether the receiver is currently disconnected, connected or
     *   attempting to connect.
     *   This operation is mandatory.
     *
     */
    static GetReceiverState(ReceiverToken: ReferenceToken): import("typescript-monads").IReader<IDeviceConfig, import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>>;
    /**
     * Returns the capabilities of the receiver service. The result is returned in a typed answer.
     */
    GetServiceCapabilities(): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Lists all receivers currently present on a device. This operation is mandatory.
     *
     */
    GetReceivers(): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Retrieves the details of a specific receiver. This operation is mandatory.
     *
     */
    GetReceiver(ReceiverToken: ReferenceToken): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Creates a new receiver. This operation is mandatory, although the service may
     *   raise a fault if the receiver cannot be created.
     *
     */
    CreateReceiver(Configuration: ReceiverConfiguration): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Deletes an existing receiver. A receiver may be deleted only if it is not
     *   currently in use; otherwise a fault shall be raised.
     *   This operation is mandatory.
     *
     */
    DeleteReceiver(ReceiverToken: ReferenceToken): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Configures an existing receiver. This operation is mandatory.
     *
     */
    ConfigureReceiver(ReceiverToken: ReferenceToken, Configuration: ReceiverConfiguration): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Sets the mode of the receiver without affecting the rest of its configuration.
     *   This operation is mandatory.
     *
     */
    SetReceiverMode(ReceiverToken: ReferenceToken, Mode: ReceiverMode): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
    /**
     *
     *   Determines whether the receiver is currently disconnected, connected or
     *   attempting to connect.
     *   This operation is mandatory.
     *
     */
    GetReceiverState(ReceiverToken: ReferenceToken): import("rxjs").Observable<import("typescript-monads").IResult<import("../soap/request").IResultStructure<any>, import("../config").ITransportPayoad>>;
}
